# PyDoll MCP Server - Claude Desktop 테스트 프롬프트 가이드

## 📋 개요

이 문서는 PyDoll MCP Server의 58개 브라우저 자동화 도구를 Claude Desktop에서 테스트할 수 있는 실용적인 프롬프트 예제를 제공합니다. 각 카테고리별로 단계적인 테스트 시나리오와 실제 사용 사례를 포함하고 있습니다.

## 🚀 빠른 시작

### 1. 설치 확인
```
PyDoll MCP 서버가 정상적으로 연결되었는지 확인해주세요. 사용 가능한 브라우저 자동화 도구들을 나열해주세요.
```

### 2. 첫 번째 테스트
```
새로운 브라우저를 시작하고 Google.com에 접속해서 "PyDoll MCP"를 검색해보세요.
```

## 🗂️ 카테고리별 테스트 프롬프트

## 1. 브라우저 관리 (Browser Management) - 8개 도구

### 기본 브라우저 조작

#### 🆕 브라우저 시작 및 관리
```
새로운 Chrome 브라우저를 시작하고, 현재 실행 중인 모든 브라우저의 상태를 확인해주세요.
```

#### 🔗 탭 관리
```
현재 브라우저에서 새 탭 3개를 열고, 각각 다른 웹사이트(YouTube, GitHub, Wikipedia)로 이동한 다음 탭 목록을 보여주세요.
```

#### 🔄 탭 전환 및 정리
```
열려있는 탭들 중에서 2번째 탭으로 전환하고, 사용하지 않는 탭들을 정리해주세요.
```

#### 🛑 브라우저 종료
```
현재 사용 중인 브라우저를 안전하게 종료해주세요.
```

## 2. 페이지 탐색 (Navigation Control) - 7개 도구

### 웹 페이지 탐색

#### 🧭 기본 탐색
```
브라우저를 시작하고 다음 순서로 이동해주세요:
1. https://example.com 접속
2. 페이지 제목과 현재 URL 확인
3. 뒤로 가기 실행
4. 페이지 새로고침
```

#### 📄 페이지 정보 수집
```
https://github.com/JinsongRoh/pydoll-mcp 에 접속해서 페이지 제목, 현재 URL, 그리고 페이지 소스의 첫 500자를 가져와주세요.
```

#### 🔍 도메인 명령어 탐색
```
현재 페이지에서 사용 가능한 Chrome DevTools 도메인 명령어들을 조회해주세요.
```

## 3. 요소 상호작용 (Element Interaction) - 4개 도구

### 웹 요소 찾기 및 조작

#### 🔎 요소 찾기 기본
```
Google.com에 접속해서 검색 입력창을 찾고, "PyDoll MCP Server"를 입력한 후 검색 버튼을 클릭해주세요.
```

#### 📝 폼 작성 자동화
```
https://httpbin.org/forms/post 에 접속해서 다음과 같이 폼을 작성해주세요:
- 이름: "Claude"
- 이메일: "claude@anthropic.com"
- 코멘트: "PyDoll MCP Server 테스트"
그리고 제출해주세요.
```

#### 🎯 고급 요소 선택
```
Wikipedia 메인 페이지에 접속해서 "Random article" 링크를 찾아 클릭하고, 그 페이지의 제목을 가져와주세요.
```

#### 👨‍👩‍👧‍👦 부모 요소 탐색
```
임의의 웹사이트에서 버튼 요소를 찾고, 그 부모 요소의 정보를 가져와주세요.
```

## 4. 스크린샷 및 미디어 (Screenshot & Media) - 3개 도구

### 화면 캡처 및 문서 생성

#### 📸 페이지 스크린샷
```
https://www.python.org 에 접속해서 전체 페이지 스크린샷을 촬영해주세요.
```

#### 🎯 특정 요소 캡처
```
GitHub 리포지토리 페이지에서 README 섹션만 따로 스크린샷을 촬영해주세요.
```

#### 📄 PDF 생성
```
현재 페이지를 PDF로 변환해서 저장해주세요. 헤더와 푸터를 포함해서 생성해주세요.
```

## 5. 스크립트 실행 (Script Execution) - 3개 도구

### JavaScript 실행 및 자동화

#### ⚡ 기본 JavaScript 실행
```
현재 페이지에서 다음 JavaScript를 실행해주세요:
- 페이지의 모든 링크 개수 세기
- 페이지 제목 변경하기
- 스크롤을 맨 아래로 이동하기
```

#### 🔧 라이브러리 주입 및 사용
```
jQuery 라이브러리를 현재 페이지에 주입하고, jQuery를 사용해서 모든 이미지 요소의 개수를 세어주세요.
```

#### 🤖 자동화 스크립트 실행
```
사전 정의된 자동화 스크립트가 있다면 실행해서 그 결과를 보여주세요.
```

## 6. 고급 자동화 (Advanced Automation) - 3개 도구

### 성능 분석 및 AI 기반 분석

#### 📊 성능 분석
```
복잡한 웹사이트(예: Amazon.com)에 접속해서 페이지 로딩 성능을 분석하고 최적화 제안사항을 제공해주세요.
```

#### 🔍 AI 콘텐츠 분석
```
뉴스 웹사이트에 접속해서 메인 기사의 감정 분석과 키워드 추출을 수행해주세요.
```

#### 🌐 네트워크 요청 분석
```
네트워크 모니터링을 활성화하고 AJAX 요청이 많은 사이트에서 API 호출들을 분석해주세요.
```

## 7. 보안 및 우회 (Protection & Stealth) - 11개 도구

### Captcha 우회 및 탐지 회피

#### 🛡️ 스텔스 모드 활성화
```
스텔스 모드를 활성화하고 봇 탐지 사이트에 접속해서 탐지 여부를 확인해주세요.
```

#### 🔐 Cloudflare 우회 테스트
```
Cloudflare 보호가 활성화된 사이트에 접속해서 자동으로 우회해주세요.
```

#### 🤖 reCAPTCHA 우회
```
reCAPTCHA가 있는 사이트에서 자동으로 우회를 시도해주세요.
```

#### 👤 인간 행동 시뮬레이션
```
인간과 같은 행동 패턴으로 웹사이트를 탐색해주세요 (랜덤 딜레이, 마우스 움직임 등).
```

#### 🎭 사용자 에이전트 변경
```
다양한 브라우저 및 기기의 사용자 에이전트로 변경하면서 접속해주세요.
```

## 8. 네트워크 모니터링 (Network Monitoring) - 10개 도구

### 네트워크 트래픽 분석

#### 📡 네트워크 모니터링 시작
```
네트워크 모니터링을 시작하고 API 호출이 많은 웹사이트에서 모든 요청을 기록해주세요.
```

#### 🚫 요청 차단
```
광고나 추적 스크립트 요청을 차단하면서 웹사이트를 탐색해주세요.
```

#### 🔧 요청 헤더 수정
```
특정 API 요청의 헤더를 수정해서 다른 결과를 받아보세요.
```

#### 🔌 WebSocket 모니터링
```
실시간 채팅이나 업데이트가 있는 사이트에서 WebSocket 연결을 모니터링해주세요.
```

#### 💾 HAR 파일 저장
```
세션의 모든 네트워크 활동을 HAR 파일로 저장해주세요.
```

## 9. 파일 관리 (File Management) - 8개 도구

### 파일 업로드/다운로드 및 데이터 처리

#### 📤 파일 업로드
```
파일 업로드 기능이 있는 사이트에서 테스트 파일을 업로드해주세요.
```

#### 📥 파일 다운로드
```
이미지나 문서 파일을 다운로드하고 다운로드 상태를 확인해주세요.
```

#### 📊 데이터 추출 및 변환
```
테이블 데이터가 있는 웹페이지에서 데이터를 추출해서 CSV와 JSON 형식으로 내보내주세요.
```

#### 💾 세션 저장 및 복원
```
현재 브라우저 세션을 저장하고, 나중에 동일한 상태로 복원해주세요.
```

## 🧪 종합 테스트 시나리오

### 실전 자동화 시나리오

#### 🛒 온라인 쇼핑 자동화
```
다음 순서로 온라인 쇼핑 프로세스를 자동화해주세요:
1. 쇼핑몰 웹사이트 접속
2. 특정 상품 검색
3. 상품 상세 페이지에서 정보 수집
4. 장바구니에 추가
5. 결제 페이지까지 진행 (실제 결제는 하지 말고)
6. 전체 과정을 스크린샷으로 기록
```

#### 📰 뉴스 스크래핑 자동화
```
뉴스 웹사이트에서 다음 작업을 수행해주세요:
1. 메인 페이지에서 헤드라인 기사 목록 수집
2. 각 기사의 제목, 요약, 링크 추출
3. 상위 3개 기사의 전체 내용 스크래핑
4. 데이터를 JSON 형식으로 정리
5. AI를 사용해서 기사 감정 분석 수행
```

#### 🔍 SEO 분석 자동화
```
웹사이트의 SEO 분석을 수행해주세요:
1. 페이지 제목과 메타 태그 추출
2. 모든 헤딩 태그(H1-H6) 분석
3. 이미지 alt 태그 확인
4. 페이지 로딩 성능 측정
5. 모바일 친화성 테스트
6. 종합 리포트 생성
```

#### 🎯 A/B 테스트 자동화
```
두 개의 다른 웹페이지 버전을 비교 분석해주세요:
1. 두 페이지에 각각 접속
2. 주요 요소들의 스크린샷 촬영
3. 로딩 성능 비교
4. 사용자 경험 요소 분석
5. 차이점 리포트 생성
```

## 🚨 에러 처리 및 디버깅

### 일반적인 문제 해결

#### 🔧 브라우저 문제 해결
```
브라우저가 응답하지 않거나 오류가 발생하면 다음을 시도해주세요:
1. 브라우저 상태 확인
2. 현재 탭 정보 확인
3. 필요시 브라우저 재시작
4. 문제 해결 후 작업 계속
```

#### 🎯 요소 찾기 실패 처리
```
요소를 찾을 수 없는 경우:
1. 페이지가 완전히 로드될 때까지 대기
2. 다른 선택자 방법 시도
3. 페이지 소스에서 요소 존재 확인
4. 대안 접근 방법 제안
```

## 📚 고급 사용법

### 복합 기능 조합

#### 🔄 자동화 워크플로우
```
다음과 같은 복합 워크플로우를 실행해주세요:
1. 스텔스 모드로 브라우저 시작
2. 프록시 설정 적용
3. 네트워크 모니터링 활성화
4. 대상 웹사이트 접속
5. 로그인 프로세스 자동화
6. 데이터 수집 및 분석
7. 결과를 파일로 저장
8. 정리 및 종료
```

#### 🎨 스크래핑 + AI 분석
```
웹 스크래핑과 AI 분석을 결합해주세요:
1. 전자상거래 사이트에서 상품 정보 수집
2. 상품 이미지들 다운로드
3. 고객 리뷰 텍스트 추출
4. AI로 리뷰 감정 분석
5. 상품 추천 점수 계산
6. 결과를 구조화된 데이터로 정리
```

## 🔍 성능 최적화 테스트

### 속도 및 효율성

#### ⚡ 속도 최적화
```
브라우저 성능을 최적화하면서 작업해주세요:
1. 불필요한 리소스 로딩 차단
2. 캐시 설정 최적화
3. 네트워크 스로틀링 적용
4. 동시 실행 작업 수 조절
5. 메모리 사용량 모니터링
```

#### 📊 벤치마크 테스트
```
다양한 설정으로 성능 벤치마크를 실행해주세요:
1. 기본 설정으로 10개 페이지 처리 시간 측정
2. 스텔스 모드 활성화 후 동일 테스트
3. 네트워크 모니터링 활성화 후 테스트
4. 결과 비교 분석 및 리포트 생성
```

## 📝 마무리

이 가이드의 프롬프트들을 통해 PyDoll MCP Server의 모든 기능을 체계적으로 테스트할 수 있습니다. 각 프롬프트는 독립적으로 실행 가능하며, 필요에 따라 조합해서 더 복잡한 자동화 시나리오를 만들 수 있습니다.

### 💡 추가 팁

- 복잡한 작업은 단계별로 나누어 실행하세요
- 오류 발생 시 중간 결과를 확인하고 디버깅하세요
- 웹사이트별 특성을 고려해서 대기 시간을 조절하세요
- 윤리적인 웹 스크래핑 원칙을 준수하세요

### 🚀 다음 단계

더 고급 기능이나 특정 사용 사례에 대한 도움이 필요하시면:
- [GitHub 리포지토리](https://github.com/JinsongRoh/pydoll-mcp) 이슈 탭에서 질문하세요
- [PyDoll 문서](https://pypi.org/project/pydoll-mcp/)를 참조하세요
- 커뮤니티 디스커션에 참여하세요

---

**PyDoll MCP Server v1.4.0** | 58개 브라우저 자동화 도구 | AI 기반 웹 자동화의 새로운 차원